Loading...
Searching...
No Matches
icu::ForwardCharacterIterator Class Referenceabstract

Abstract class that defines an API for forward-only iteration on text objects. More...

`#include <chariter.h>`

Inheritance diagram for icu::ForwardCharacterIterator:

## Public Types

enum | { DONE = 0xffff }
| Value returned by most of ForwardCharacterIterator's functions when the iterator has reached the limits of its iteration. More...

## Public Member Functions

virtual | ~ForwardCharacterIterator ()
| Destructor.
virtual bool | operator== (const ForwardCharacterIterator &that) const =0
| Returns true when both iterators refer to the same character in the same character-storage object.
bool | operator!= (const ForwardCharacterIterator &that) const
| Returns true when the iterators refer to different text-storage objects, or to different characters in the same text-storage object.
virtual int32_t | hashCode () const =0
| Generates a hash code for this iterator.
virtual UClassID | getDynamicClassID () const override=0
| Returns a UClassID for this ForwardCharacterIterator ("poor man's RTTI").
virtual char16_t | nextPostInc ()=0
| Gets the current code unit for returning and advances to the next code unit in the iteration range (toward endIndex()).
virtual UChar32 | next32PostInc ()=0
| Gets the current code point for returning and advances to the next code point in the iteration range (toward endIndex()).
virtual UBool | hasNext ()=0
| Returns false if there are no more code units or code points at or after the current position in the iteration range.
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor.

## Protected Member Functions

| ForwardCharacterIterator ()
| Default constructor to be overridden in the implementing class.
| ForwardCharacterIterator (const ForwardCharacterIterator &other)
| Copy constructor to be overridden in the implementing class.
ForwardCharacterIterator & | operator= (const ForwardCharacterIterator &)
| Assignment operator to be overridden in the implementing class.

## Detailed Description

Abstract class that defines an API for forward-only iteration on text objects.

This is a minimal interface for iteration without random access or backwards iteration. It is especially useful for wrapping streams with converters into an object for collation or normalization.

Characters can be accessed in two ways: as code units or as code points. Unicode code points are 21-bit integers and are the scalar values of Unicode characters. ICU uses the type UChar32 for them. Unicode code units are the storage units of a given Unicode/UCS Transformation Format (a character encoding scheme). With UTF-16, all code points can be represented with either one or two code units ("surrogates"). String storage is typically based on code units, while properties of characters are typically determined using code point values. Some processes may be designed to work with sequences of code units, or it may be known that all characters that are important to an algorithm can be represented with single code units. Other processes will need to use the code point access functions.

ForwardCharacterIterator provides nextPostInc() to access a code unit and advance an internal position into the text object, similar to a `return text[position++]`.
It provides next32PostInc() to access a code point and advance an internal position.

next32PostInc() assumes that the current position is that of the beginning of a code point, i.e., of its first code unit. After next32PostInc(), this will be true again. In general, access to code units and code points in the same iteration loop should not be mixed. In UTF-16, if the current position is on a second code unit (Low Surrogate), then only that code unit is returned even by next32PostInc().

For iteration with either function, there are two ways to check for the end of the iteration. When there are no more characters in the text object:

- The hasNext() function returns false.
- nextPostInc() and next32PostInc() return DONE when one attempts to read beyond the end of the text object.

Example:

void function1(ForwardCharacterIterator &it) {
UChar32 c;
while(it.hasNext()) {
c=it.next32PostInc();
// use c
}
}
void function1(ForwardCharacterIterator &it) {
char16_t c;
while((c=it.nextPostInc())!=ForwardCharacterIterator::DONE) {
// use c
}
}
icu::ForwardCharacterIterator::next32PostInc
virtual UChar32 next32PostInc()=0
Gets the current code point for returning and advances to the next code point in the iteration range ...
icu::ForwardCharacterIterator::ForwardCharacterIterator
ForwardCharacterIterator()
Default constructor to be overridden in the implementing class.
icu::ForwardCharacterIterator::hasNext
virtual UBool hasNext()=0
Returns false if there are no more code units or code points at or after the current position in the ...
UChar32
int32_t UChar32
Define UChar32 as a type for single Unicode code points.
Definition umachine.h:449

Stable
  ICU 2.0

Definition at line 94 of file chariter.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Value returned by most of ForwardCharacterIterator's functions when the iterator has reached the limits of its iteration.

Stable
  ICU 2.0

Definition at line 101 of file chariter.h.

## Constructor & Destructor Documentation

## ~ForwardCharacterIterator()

virtual icu::ForwardCharacterIterator::~ForwardCharacterIterator | ( |  | ) |

virtual

Destructor.

Stable
  ICU 2.0

## ForwardCharacterIterator() [1/2]

icu::ForwardCharacterIterator::ForwardCharacterIterator | ( |  | ) |

protected

Default constructor to be overridden in the implementing class.

Stable
  ICU 2.0

Referenced by ForwardCharacterIterator(), operator!=(), operator=(), and operator==().

## ForwardCharacterIterator() [2/2]

icu::ForwardCharacterIterator::ForwardCharacterIterator | ( | const ForwardCharacterIterator & | other | ) |

protected

Copy constructor to be overridden in the implementing class.

Stable
  ICU 2.0

References ForwardCharacterIterator().

## Member Function Documentation

## getDynamicClassID()

virtual UClassID icu::ForwardCharacterIterator::getDynamicClassID | ( |  | ) | const

override pure virtual

Returns a UClassID for this ForwardCharacterIterator ("poor man's RTTI").

Despite the fact that this function is public, DO NOT CONSIDER IT PART OF CHARACTERITERATOR'S API!

Returns
  a UClassID for this ForwardCharacterIterator

Stable
  ICU 2.0

Reimplemented from icu::UObject.

Implemented in icu::StringCharacterIterator, and icu::UCharCharacterIterator.

## hashCode()

virtual int32_t icu::ForwardCharacterIterator::hashCode | ( |  | ) | const

pure virtual

Generates a hash code for this iterator.

Returns
  the hash code.

Stable
  ICU 2.0

Implemented in icu::UCharCharacterIterator.

## hasNext()

virtual UBool icu::ForwardCharacterIterator::hasNext | ( |  | ) |

pure virtual

Returns false if there are no more code units or code points at or after the current position in the iteration range.

This is used with nextPostInc() or next32PostInc() in forward iteration.

Returns
  false if there are no more code units or code points at or after the current position in the iteration range.

Stable
  ICU 2.0

Implemented in icu::UCharCharacterIterator.

## next32PostInc()

virtual UChar32 icu::ForwardCharacterIterator::next32PostInc | ( |  | ) |

pure virtual

Gets the current code point for returning and advances to the next code point in the iteration range (toward endIndex()).

If there are no more code points to return, returns DONE.

Returns
  the current code point.

Stable
  ICU 2.0

Implemented in icu::UCharCharacterIterator.

## nextPostInc()

virtual char16_t icu::ForwardCharacterIterator::nextPostInc | ( |  | ) |

pure virtual

Gets the current code unit for returning and advances to the next code unit in the iteration range (toward endIndex()).

If there are no more code units to return, returns DONE.

Returns
  the current code unit.

Stable
  ICU 2.0

Implemented in icu::UCharCharacterIterator.

## operator!=()

bool icu::ForwardCharacterIterator::operator!= | ( | const ForwardCharacterIterator & | that | ) | const

inline

Returns true when the iterators refer to different text-storage objects, or to different characters in the same text-storage object.

Parameters

  that | The ForwardCharacterIterator to be compared for inequality

Returns
  true when the iterators refer to different text-storage objects, or to different characters in the same text-storage object

Stable
  ICU 2.0

Definition at line 696 of file chariter.h.

References ForwardCharacterIterator(), operator!=(), and operator==().

Referenced by operator!=().

## operator=()

ForwardCharacterIterator & icu::ForwardCharacterIterator::operator= | ( | const ForwardCharacterIterator & |  | ) |

inline protected

Assignment operator to be overridden in the implementing class.

Stable
  ICU 2.0

Definition at line 189 of file chariter.h.

References ForwardCharacterIterator().

## operator==()

virtual bool icu::ForwardCharacterIterator::operator== | ( | const ForwardCharacterIterator & | that | ) | const

pure virtual

Returns true when both iterators refer to the same character in the same character-storage object.

Parameters

  that | The ForwardCharacterIterator to be compared for equality

Returns
  true when both iterators refer to the same character in the same character-storage object

Stable
  ICU 2.0

Implemented in icu::StringCharacterIterator, and icu::UCharCharacterIterator.

References ForwardCharacterIterator().

Referenced by operator!=().

The documentation for this class was generated from the following file:

- common/unicode/chariter.h